#include <SoftwareSerial.h>
#include "zBus.h"

zBus RS485; 

struct Packet{
  uint8_t command;
  int16_t data;
};

Packet packet;
SoftwareSerial SerialRS485(10, 11);

#define LED   13

uint32_t ledTime;
int16_t  ledPeriod = 500;

void setup(){
  SerialRS485.begin(9600);
  // inicializace Slave zarizeni s adresou 10, pin D3 ridi smes komunikace
  RS485.beginSlave(&SerialRS485, 10, 3);
  pinMode(LED, OUTPUT); 
}

uint16_t hodnota;

void loop(){

  // je-li prijata zprava  
  if (RS485.readData(&packet, sizeof(packet)) == NO_ERROR) {
    // a zprava ma v polozce command hodnotu W  
    if (packet.command == 'W') {
      // tak nastavi periodu blikani LED na hodnotu predanou v polozce data
      ledPeriod = packet.data;
    }
  }

  if (millis() - ledTime >= ledPeriod) {
    digitalWrite(LED, !digitalRead(LED));
    ledTime += ledPeriod;
  }  
}
