#ifndef __zBus_H__
#define __zBus_H__

#include "Arduino.h"
#include "Stream.h"

#define NO_DATA       0
#define NO_ERROR      255
#define ERROR_TIMEOUT 1
#define ERROR_REQUEST 2
#define ERROR_CRC     3

#define MAX_LEN       16+2
#define NO_ADDRESS    255
#define TIMEOUT       1000
  
class zBus {
  public:
    zBus();
    void      beginMaster(Stream* _stream, int8_t _RxTx = -1);
    void      beginSlave (Stream* _stream, uint8_t _selfId, int8_t _RxTx = -1);
    void      sendData(void* _data, uint8_t _size, uint8_t _targetId = 0, uint8_t _request = 0);
    void      sendData(const char* _data, uint8_t _targetId = 0, uint8_t _request = 0);
    boolean   availableData();
    uint8_t   getStatus();
    void      getData(void* _data, uint8_t _maxSize);
    uint8_t   readData(void* _data, uint8_t _maxSize);
  private:
    Stream    *stream;
    uint8_t   *packet;     //address of struct
    uint8_t   dataSize;    //size of struct
    uint8_t   rxBuffer[MAX_LEN];   //parsing buffer
    uint8_t   rxIndex;     //index for RX parsing buffer
    uint8_t   state;  // 
    uint8_t   selfId;  // self address (0 .., master)
    int8_t    RxTx;
    uint32_t  timeStamp, timeOut;
    uint8_t   masterSlave;  // master

    void      setIdleState(uint8_t _reguest = 0);
};



#endif
